# -*- coding: utf-8 -*-
"""
Created on Wed Apr 25 13:54:53 2018

@author: eivin
"""

from abaqus import *
from abaqusConstants import *
import __main__

import datetime
import section
import regionToolset
import displayGroupMdbToolset as dgm
import part
import material
import assembly
import step
import interaction
import load
import mesh
import optimization
import job
import sketch
import visualization
import xyPlot
import displayGroupOdbToolset as dgo
import connectorBehavior
import sys
import os


def getUsefulPar(fileName):
    file = open(fileName)
    for line in file:
        par = line.split()
    modelName = par[0]
    dX = float(par[1])
    dY = float(par[2])
    dZ = float(par[3])
    esize = float(par[4])
    tol = float(par[5])
    file.close()
    return(dX,dY,dZ,esize,tol)
    
#def results(modelName,dX,dY,th,mps,esize,eName):  
#    
#    # Number of steps in stepNum
#    stepNum = 1
#    
#    # Linear
#
#    odbName = 'Job-'+modelName+'-tensile.odb'
#    odb = session.openOdb(odbName)
#    
#    # The sets of nodes found in the result file:
#    regOdbYB=odb.rootAssembly.nodeSets['SET-NODES-YB']
##    dispNode=odb.rootAssembly.nodeSets['SET-NODES-YB'].nodes[0][0]
#    
##    outFileName=odbName.split('.')[0]+'.txt' 
##    f=open(outFileName,'a')
#   
#    for i in range(stepNum):
#        ip = str(i+1)
#        res=''
#        
#        f=open(resFile,'a')
#    
#        frame = odb.steps['Step-InPlaneY-L'+ip].frames[-1]
#        rfsYB=frame.fieldOutputs['RF'].getSubset(region=regOdbYB).values
#        
#        sumNy=0 # to be incrementally summed...
#        for rfYB in rfsYB:   
#            rfy=rfYB.data[1]
#            sumNy=sumNy+rfy
#        Ny=sumNy/(dX) 
##            uy=frame.fieldOutputs['U'].getSubset(region=dispNode).values[-1].data[1]
##            epsY=uy/dY
##            res=res+ str(epsY)+','+str(Ny)+'\n'
#        Ayy = Ny/mps
#        res = res + modelName + '\t' + eName + '\t' + str(esize) + '\t' + str(Ayy) +'\n'
#       
#        f.write(res)
#        f.close()
    
    
    
def getCoordinateFromLabel(label,subset):
    for n in subset.values:
        if n.nodeLabel==label:
           return n.data[0], n.data[1], n.data[2]
    return 'fds'
    
def getLoadCaseResult(odbFileName,DX,DY,DZ,tol):
    odb=session.openOdb(odbFileName)
    regXA=odb.rootAssembly.nodeSets['SET-NODES-XA']
    regYA=odb.rootAssembly.nodeSets['SET-NODES-YA']
    
    # Force X at XA: 
    FxSumXA=0.0
    MxSumXA=0.0
    nforce1XA=odb.steps['Step-1'].frames[-1].fieldOutputs['NFORC1'].getSubset(region=regXA)
    coordXA=odb.steps['Step-1'].frames[-1].fieldOutputs['COORD'].getSubset(region=regXA)
    for n in nforce1XA.values:
        x,y,z =getCoordinateFromLabel(n.nodeLabel,coordXA)
        FxSumXA = FxSumXA + n.data
        MxSumXA = MxSumXA + n.data*z
            
    # Force Y at XA: 
    FySumXA=0.0
    MsSumXA=0.0
    nforce2XA=odb.steps['Step-1'].frames[-1].fieldOutputs['NFORC2'].getSubset(region=regXA)
    coordXA=odb.steps['Step-1'].frames[-1].fieldOutputs['COORD'].getSubset(region=regXA)
    for n in nforce2XA.values:
        x,y,z =getCoordinateFromLabel(n.nodeLabel,coordXA)
        FySumXA = FySumXA + n.data
        MsSumXA = MsSumXA + n.data*z

    # Force Z at XA:
    nforce3XA=odb.steps['Step-1'].frames[-1].fieldOutputs['NFORC3'].getSubset(region=regXA)
    coordXA=odb.steps['Step-1'].frames[-1].fieldOutputs['COORD'].getSubset(region=regXA)
    for n in nforce3XA.values:
        x,y,z =getCoordinateFromLabel(n.nodeLabel,coordXA)
        contribution=n.data*y
        if abs(y-0.5*DY) < tol:
           contribution= 0.5*contribution
        if abs(y+0.5*DY) < tol:
           contribution= 0.5*contribution
        MsSumXA = MsSumXA - contribution
    
    # Force Y at YA: 
    FySumYA=0.0
    MySumYA=0.0
    nforce2YA=odb.steps['Step-1'].frames[-1].fieldOutputs['NFORC2'].getSubset(region=regYA)
    coordYA=odb.steps['Step-1'].frames[-1].fieldOutputs['COORD'].getSubset(region=regYA)
    for n in nforce2YA.values:
        x,y,z =getCoordinateFromLabel(n.nodeLabel,coordYA)
        FySumYA = FySumYA + n.data
        MySumYA = MySumYA + n.data*z
     
    # Force X at YA: 
    FxSumYA=0.0
    MsSumYA=0.0
    nforce1YA=odb.steps['Step-1'].frames[-1].fieldOutputs['NFORC1'].getSubset(region=regYA)
    coordYA=odb.steps['Step-1'].frames[-1].fieldOutputs['COORD'].getSubset(region=regYA)
    for n in nforce1YA.values:
        x,y,z =getCoordinateFromLabel(n.nodeLabel,coordYA)
        FxSumYA = FxSumYA + n.data
        MsSumYA = MsSumYA + n.data*z

    # Force Z at YA:
    nforce3YA=odb.steps['Step-1'].frames[-1].fieldOutputs['NFORC3'].getSubset(region=regYA)
    coordYA=odb.steps['Step-1'].frames[-1].fieldOutputs['COORD'].getSubset(region=regYA)
    for n in nforce3YA.values:
        x,y,z =getCoordinateFromLabel(n.nodeLabel,coordYA)
        contribution=n.data*x
        if abs(x-0.5*DX) < tol:
           contribution=0.5*contribution
        if abs(x+0.5*DX) < tol:
           contribution=0.5*contribution
        MsSumYA = MsSumYA - contribution

    return(FxSumXA/DY, FySumYA/DX, (FxSumYA/DX+FySumXA/DY)/2.0, MxSumXA/DY, MySumYA/DX, (MsSumYA/DX+MsSumXA/DY)/2.0)
    
def fileWriteArray(fileName,model,array,rdigits,zeroThreshold):
#    text=model+'\n'
    text=''
    shortLine=''    
#    for line in array:
#        textLine=''
#        for value in line:
#            if abs(value)<zeroThreshold:
#               value=0.0
#            rvalue=round(value,rdigits)
#            textLine=textLine+str(rvalue)+'\t'
#        text=text+textLine+'\n'
    shortLine=shortLine+str( round(array[0][0],rdigits) ) + '\t'
    shortLine=shortLine+str( round(array[1][1],rdigits) ) + '\t'
    shortLine=shortLine+str( round(array[0][1],rdigits) ) + '\t'
    shortLine=shortLine+str( round(array[2][2],rdigits) ) + '\t'
    shortLine=shortLine+str( round(array[3][3],rdigits) ) + '\t'
    shortLine=shortLine+str( round(array[4][4],rdigits) ) + '\t'
    shortLine=shortLine+str( round(array[3][4],rdigits) ) + '\t'
    shortLine=shortLine+str( round(array[5][5],rdigits) )
    print(text)
    print(shortLine)
    text=text+shortLine
    text=text+'\n'
    f=open(fileName,'a')
    f.write(text)
    f.close()
    
    
def printStuff(odbName):
    timestamp = datetime.datetime.now().strftime('-%Y-%d-%m-%H-%M-%S')
    session.openOdb(name=odbName)
    odbObj = session.odbs[odbName]
    
    session.psOptions.setValues(paperSize=A4, logo=OFF, date=OFF)
    session.viewports['Viewport: 1'].setValues(displayedObject=odbObj)
    session.viewports['Viewport: 1'].view.setValues(session.views['Iso'])
    session.viewports['Viewport: 1'].view.fitView()
#    session.viewports['Viewport: 1'].odbDisplay.display.setValues(plotState=(
#            CONTOURS_ON_DEF, ))
    session.viewports['Viewport: 1'].odbDisplay.display.setValues(plotState=(
            UNDEFORMED, ))
    session.printToFile(fileName=modelName+'-'+timestamp, format=PNG, 
                        canvasObjects=(session.viewports['Viewport: 1'], ))
    numElems = len(odbObj.rootAssembly.instances['MESHPART2-1'].elements)
    el=open(elemFile,'a')
    el.write(str(numElems)+'\t')
    el.close()
    session.odbs[odbName].close()
    
# Main program
lineStart = int(sys.argv[-2])
numLines = int(sys.argv[-1])
case = 'ct'

resFile = 'meshConvResults-'+str(lineStart)+'-'+str(lineStart+numLines-1)+'.txt'
elemFile = 'elementNumbers-'+str(lineStart)+'-'+str(lineStart+numLines-1)+'.txt'
f=open(resFile,'w')
f.write('A11\tA22\tA12\tA66\tD11\tD22\tD12\tD66\n')
f.close()

el=open(elemFile,'w')
el.write('')
el.close()

for i in range(lineStart, lineStart+numLines):
    resultArray=list()
    for counter in range(6):
        if i<10:
            ip = str(i)
            ipL = str(i)+'-L'
            baseModel = case+'-m00'+ip
            modelName = case+'-m00'+ip+'-'+str(counter)
            fileName = 'usefulFile-'+baseModel+'.txt'
        elif i<100:
            ip = str(i)+'-L'
            baseModel = case+'-m0'+ip
            modelName = case+'-m0'+ip+'-'+str(counter)
            fileName = 'usefulFile-'+baseModel+'.txt'
        else: 
            ip = str(i)+'-L'
            baseModel = case+'-m'+ip
            modelName = case+'-m'+ip+'-'+str(counter)
            fileName = 'usefulFile-'+baseModel+'.txt'
        
        dX,dY,dZ,esize,tol = getUsefulPar(fileName)
        resultArray.append(getLoadCaseResult(modelName+'.odb',2.0*dX,2.0*dY,2.0*dZ,tol))
#            results(modelName,dX,dY,th,MidPlainStrain,esize,eName)
    printStuff(modelName+'.odb')
    fileWriteArray(resFile,baseModel,resultArray,2,1E-06)