# -*- coding: utf-8 -*-
"""
Created on Mon Apr  9 16:43:36 2018

@author: eivin
"""

import sys
import numpy as np
import os, errno
#import os
import time
import subprocess as sp
import matplotlib.pyplot as plt

def getDataFiles():
    dataFile=open(dataFileName)    
    modelsData=[]
    for line in dataFile:
        dataList=[]
        data=line.split()
        for d in data:
            dataList.append(d.strip(' \t\n\r'))
        modelsData.append(dataList)         
    dataFile.close()
    
    if len(modelsData) < numLines:
        print('Too many jobs requested!\n')
        sys.exit(0)
    elif (lineStart-1) < 0:
        print('Invalid start number!\n')
        sys.exit(0)
    elif (len(modelsData)-(lineStart-1)) < numLines:
        print('Not enough datalines left to give', numLines,'results\n')   
        sys.exit(0)
    else:
        print('Number of lines accepted!\n')
    return(modelsData) 
    
def makeTheDir(lineStart, numLines):
    start = str(lineStart)
    end = str(lineStart+numLines-1)
    dirName ='pb_'+start+'_to_'+end+'h'
    try:
        os.makedirs(dirName)
    except OSError as e:
        if e.errno != errno.EEXIST:
            raise
    return(dirName)
    
def makeModelBatches(lineStart, numLines):
    start = str(lineStart)
    num = str(numLines)
    
    batch = open('batch.bat','w')
    lines =  ['abaqus cae script=',mainDir,'\\',case,'_abaqus.py -- ', start+' ', num+' ', dataFileName+' ', str(numSteps)]
    batch.writelines(lines)
    batch.close()

def runModelBatch():        
    sp.call('batch.bat')

def makeJobBatch():
    
    for i in range(lineStart, lineStart+numLines):
        if i < 10:
            jobName = case+'-m00'+str(i)
            jobNameL = case+'-m00'+str(i)+'-L'
        elif i < 100:
            jobName = case+'-m0'+str(i)
            jobNameL = case+'-m0'+str(i)+'-L'
        else:
            jobName = case+'-m'+str(i)
            jobNameL = case+'-m'+str(i)+'-L'
        jobs = open('jobSubmit'+str(i)+'.bat','w')
        jobs.write('')
        jobs.close()
        jobs = open('jobSubmit'+str(i)+'.bat','a')
        jobs.write('(\n')        
        lines = ['abaqus job=', jobName, ' ', 'input=', jobName, ' ask_delete=OFF','\n']
        linesL = ['abaqus job=', jobNameL, ' ', 'input=', jobNameL, ' ask_delete=OFF', '\n']
        jobs.writelines(lines)
        jobs.writelines(linesL)
        jobs.write(')')    
        jobs.close()
    
def submitJobs():
    print('Running Jobs...\n')
    for i in range(lineStart, lineStart+numLines):
        sp.call('jobSubmit'+str(i)+'.bat')
        checker(2)
        checker(3)
         

def checker(var):
    if var == 1:
        check = 0
        while check == 0:    
            for fname in os.listdir(jobDir):
                if fname.endswith('.inp'):
                    check = 1
                    break
            else:
                time.sleep(0.1)
                
    elif var == 2:
        check = 0
        while check == 0:    
            for fname in os.listdir(jobDir): # '.' - means current directory
                if fname.endswith('.lck'):
                    check = 1
                    break
            else:
                time.sleep(1)
                
    elif var == 3:
        check = 0
        while check == 0:    
            for fname in os.listdir(jobDir): # '.' - means current directory
                if fname.endswith('.lck'):
                    time.sleep(1)
                    break
            else:
                check = 1
    
def getResults():
    s = str(lineStart)
    n = str(numLines)
    command ='abaqus cae script=',mainDir,'\\',case,'_results.py -- {0} {1} {2}'.format(numSteps,s,n)
    
    results = open('results.bat','w')
    results.writelines(command)
    results.close()
    sp.call('results.bat')
    
def plotResults(r,mDat):
   
    x = []
    y = []
    xL = []
    yL = []
    docName = 'values'+str(lineStart)+'-'+str(lineStop)+'.txt'
    values = open(docName, 'w')                                  
    line = ['Name','\t', 'Strain','\t', 'Load', '\n']
    values.writelines(line)
    values.close()
    values = open(docName, 'a')
    for i in range(lineStart, lineStop+1):
        nl ='Non-linear'
        l = 'Linear'
         # Non-linear
        print(i)
        plt.figure()
        if i<10:
            ip = str(i)
            x, y = np.loadtxt(case+'-m00'+ip+'.txt', delimiter='\t', unpack=True)
            plt.plot(x,y,label=nl,ls='--',c='b')
        elif i<100:
            ip = str(i)
            x, y = np.loadtxt(case+'-m0'+ip+'.txt', delimiter='\t', unpack=True)
            plt.plot(x,y,label=nl,ls='--',c='b')
        else: 
            ip = str(i)
            x, y = np.loadtxt(case+'-m'+ip+'.txt', delimiter='\t', unpack=True)
            plt.plot(x,y,label=nl,ls='--',c='b')
            
         # Linear        
        if i<10:            
            xL, yL = np.loadtxt(case+'-m00'+ip+'-L.txt', delimiter='\t', unpack=True)
            plt.plot(xL,yL,label=l,c='tab:orange')
        elif i<100:
            ip = str(i)
            xL, yL = np.loadtxt(case+'-m0'+ip+'-L.txt', delimiter='\t', unpack=True)
            plt.plot(xL,yL,label=l,c='tab:orange')
        else: 
            ip = str(i)
            xL, yL = np.loadtxt(case+'-m'+ip+'-L.txt', delimiter='\t', unpack=True)
            plt.plot(xL,yL,label=l,c='tab:orange')
            
        errCurvature, errMoment, preValCurvature, preValMoment, diffErr, diffPre = errorCrit(x,y,xL,yL)
        criticalCurvature = (errCurvature + preValCurvature)/2
#        criticalMoment = (errMoment+preValMoment)/2
#        xErr, yErr = [criticalCurvature, criticalCurvature], [0, criticalMoment]
#        xErr2, yErr2 = [0, criticalCurvature], [criticalMoment, criticalMoment]
        xErr, yErr = [errCurvature, errCurvature], [0, errMoment]
        xErr2, yErr2 = [preValCurvature, preValCurvature], [0, preValMoment]
        plt.plot(xErr, yErr, marker =',',c='r',lw=1)
        plt.plot(xErr2, yErr2, marker =',',c='r',lw=1)
#        myText = str(criticalPoint)
#        plt.text(criticalCurvature, criticalMoment*0.5, myText)
#        plt.text(0, criticalMoment*1.1, criticalMoment)
#        plt.text(criticalCurvature*1.05, 0, criticalCurvature)
        if lineStart == 1:
            parameterVar=5
        elif lineStart == 7:
            parameterVar=7
        elif lineStart == 13:
            parameterVar=6
        elif lineStart == 19:
            parameterVar=4
        parameters = modelsData[i-1][parameterVar]
        line = [mDat[i-1][0], '\t', str(parameters), '\t', str(criticalCurvature), '\n']
        values.writelines(line)
        plt.legend()
        plt.xlabel('Curvature about Y, Ky')
        plt.ylabel('Moment about Y, My')
        plt.title('Cylindrical bending of Slits')
        plt.xlim(0,)
        plt.ylim(0,)
        plt.show()
    
        plt.savefig('C:\\Users\\Eivind\\OneDrive - NTNU\\Master\\Just pictures\\Results from parameter study\\'+case+'-'+str(i)+'.png')
        plt.savefig('C:\\Users\\Eivind\\OneDrive - NTNU\\Master\\Just pictures\\Results from parameter study\\'+case+'-'+str(i)+'.pdf',format='pdf')
    values.close()
    return(docName)
    
def errorCrit(x,y,xL,yL):
    # This function will find the strain and the load calues at the specific error criteria  
    diff=[]
    for i in range(len(x)):
        if i == 0:            
            diff.append(0)
            continue
        else:
#            print(x[i])
#            print(y[i])
#            h = (y[i]-y[i-1])/(x[i]-x[i-1])
            
            h = y[i]
            hL = yL[i]
            print(hL)
            print(h)
            diff.append(h/hL)
            
            
        if (1-error) < diff[i] < (1+error):
            mess = 'Inside error criteria!'
#            diff[i] = (h-hL)/(hL)
            print('The difference is: ', diff[i])
            valX = 0
            valY = 0
            prevalX = 0
            prevalY = 0
            
        else:
            mess = 'Error criteria reached!'
            valX = x[i]
            valY = y[i]
            prevalX = x[i-1]
            prevalY = y[i-1]
            print('The difference is: ', diff[i])
            
            break
        print(mess)
        
    print(mess)
    return(valX,valY,prevalX,prevalY,diff[i],diff[i-1])
    
def plotLast(file):
    transVal = np.loadtxt(file, delimiter='\t', skiprows=1, usecols=2, unpack=False)
    par = np.loadtxt(file, delimiter='\t', skiprows=1, usecols=1, unpack=True)
    print(transVal)
    print(par)
    label=0
    if lineStart == 1:
        label='b'
    elif lineStart == 7:
        label='d'
    elif lineStart == 13:
        label='c'
    elif lineStart == 19:
        label='a'
    
    plt.figure()
    plt.plot(par,transVal,label='',ls='-',c='r')
    
    
    plt.xlabel('Parameter variation of '+label+', [mm]')
    plt.ylabel('Non-linear transition, [Curvature]')
    plt.title('Cylindrical bending of Slits')
#    plt.legend()
    plt.show()
    plt.savefig('C:\\Users\\Eivind\\OneDrive - NTNU\\Master\\Just pictures\\Results from parameter study\\'+'variation_of_'+label+'.png')
    plt.savefig('C:\\Users\\Eivind\\OneDrive - NTNU\\Master\\Just pictures\\Results from parameter study\\'+'variation_of_'+label+'.pdf',format='pdf')
# =============================================================================
# Global parameters
# =============================================================================
error = 0.10
numSteps = 10
case = 'pb'
mainDir = 'C:\\Users\\Eivind\\Documents\\Master\\FinalAnalysis\\Geometric\\PureBending'
#printNumber = 1
# =============================================================================
# Main program
# =============================================================================

#lineStart = int(input('What is the start line in the models data? '))
#numLines = int(input('How many models shall be created an run? '))
lineStart = 1
numLines = 1
lineStop = lineStart + numLines - 1


os.chdir(mainDir)
dirName = makeTheDir(lineStart, numLines)
os.chdir(os.getcwd()+'\\'+dirName)
jobDir = os.getcwd()
dataFileName = mainDir +'\\modelsData.txt'

modelsData = getDataFiles()

makeModelBatches(lineStart, numLines)
runModelBatch()

checker(1)
    
print('The models are done!\n')

makeJobBatch()
submitJobs()


print('The simulations are done!\n')

#getResults()
#valDoc = plotResults(numLines, modelsData)
#plotLast(valDoc)
