# -*- coding: utf-8 -*-
"""
Created on Mon Apr  9 17:03:32 2018

@author: eivin
"""

from abaqus import *
from abaqusConstants import *
import __main__

import datetime
import section
import regionToolset
import displayGroupMdbToolset as dgm
import part
import material
import assembly
import step
import interaction
import load
import mesh
import optimization
import job
import sketch
import visualization
import xyPlot
import displayGroupOdbToolset as dgo
import connectorBehavior
import sys


def getUsefulPar(fileName):
    file = open(fileName)
    for line in file:
        par = line.split('\t')
    modelName = par[0]
    dX = float(par[1])
    dY = float(par[2])
    th = float(par[3])
    ky = float(par[4])
    file.close()
    return(modelName,dX,dY,th,ky)
    
def results(modelName,dX,dY,th,ky):  
    # Non-linear
    odbName = modelName+'.odb'
    odb = session.openOdb(odbName)
    
    # The sets of nodes found in the result file:
    regOdbYB=odb.rootAssembly.nodeSets['SET-NODES-YB']
#    dispNode=odb.rootAssembly.nodeSets['SET-NODES-YB'].nodes[0][0]
    momentNode=odb.rootAssembly.nodeSets['SET-NODE-MOMENT']
    outFileName=odbName.split('.')[0]+'.txt'
    
    
    C=0
    curvature = ky/numSteps
    for i in range(numSteps):
        ip = str(i+1)
        res=''
        
        par=curvature/len(odb.steps['Step-BendingY-NL'+ip].frames)
        
        if i == 0:
            f=open(outFileName,'w')
#            allFrames=odb.steps['Step-BendingY-NL'+ip].frames
##            C=C+par
#            rfsYB=allFrames[0].fieldOutputs['RF'].getSubset(region=regOdbYB).values
#            momentNode=odb.rootAssembly.nodeSets['SET-NODE-MOMENT']
#            y0=momentNode.nodes[0][0].coordinates[1]
#            z0=momentNode.nodes[0][0].coordinates[2]
#            
#            sumMy=0 # to be incrementally summed...
#            for counter, rfYB in enumerate(rfsYB):
#                
#                rfy=rfYB.data[1]
#                rfz=rfYB.data[2]
#                
#                y=regOdbYB.nodes[0][counter].coordinates[1]
#                z=regOdbYB.nodes[0][counter].coordinates[2]
#                
#                armY=y-y0
#                armZ=z-z0
#                
#                momY1=rfy*armZ
#                momY2=-rfz*armY
#                momY=momY1+momY2
#                sumMy=sumMy+momY
#                
#            res=res+str(C)+'\t'+str(sumMy)+'\n'
        else:
            f=open(outFileName,'a')
        for frame in odb.steps['Step-BendingY-NL'+ip].frames:
            allFrames=odb.steps['Step-BendingY-NL'+ip].frames
            C=C+par
#            C=C+curvature
#            rfsYB=allFrames[-1].fieldOutputs['RF'].getSubset(region=regOdbYB).values
            rfsYB=frame.fieldOutputs['RF'].getSubset(region=regOdbYB).values
            momentNode=odb.rootAssembly.nodeSets['SET-NODE-MOMENT']
            y0=momentNode.nodes[0][0].coordinates[1]
            z0=momentNode.nodes[0][0].coordinates[2]
            
            sumMy=0 # to be incrementally summed...
            for counter, rfYB in enumerate(rfsYB):
#                if counter == 0:
#                    continue
#                else:
                rfy=rfYB.data[1]
                rfz=rfYB.data[2]
                
                y=regOdbYB.nodes[0][counter].coordinates[1]
                z=regOdbYB.nodes[0][counter].coordinates[2]
                
                armY=y-y0
                armZ=z-z0
                
                momY1=rfy*armZ
                momY2=-rfz*armY
                momY=momY1+momY2
                sumMy=sumMy+momY
            
        res=res+str(C)+'\t'+str(sumMy)+'\n'
    
        f.write(res)
        f.close()
    
    # Linear
    modelNameL = modelName + '-L'
    odbName = modelNameL+'.odb'
    odb = session.openOdb(odbName)
    
    # The sets of nodes found in the result file:
    regOdbYB=odb.rootAssembly.nodeSets['SET-NODES-YB']
#    dispNode=odb.rootAssembly.nodeSets['SET-NODES-YB'].nodes[0][0]
    momentNode=odb.rootAssembly.nodeSets['SET-NODE-MOMENT']
    outFileName=odbName.split('.')[0]+'.txt'
    
    C=0
    E=0
    curvature = ky/numSteps
    for i in range(numSteps):
        ip = str(i+1)
        res=''
        
        par=curvature/len(odb.steps['Step-BendingY-L'+ip].frames)
        
        if i == 0:
            f=open(outFileName,'w')
        else:
            f=open(outFileName,'a')
            
        if i == 0:
            for frame in odb.steps['Step-BendingY-L'+ip].frames:
                C=C+par
                rfsYB=frame.fieldOutputs['RF'].getSubset(region=regOdbYB).values
                momentNode=odb.rootAssembly.nodeSets['SET-NODE-MOMENT']
                y0=momentNode.nodes[0][0].coordinates[1]
                z0=momentNode.nodes[0][0].coordinates[2]
                
                sumMy=0 # to be incrementally summed...
                for counter, rfYB in enumerate(rfsYB):
                    rfy=rfYB.data[1]
                    rfz=rfYB.data[2]
                    
                    y=regOdbYB.nodes[0][counter].coordinates[1]
                    z=regOdbYB.nodes[0][counter].coordinates[2]
                    
                    armY=y-y0
                    armZ=z-z0
                    
                    momY1=rfy*armZ
                    momY2=-rfz*armY
                    momY=momY1+momY2
                    sumMy=sumMy+momY
            E = sumMy/C        
        else:
            for frame in odb.steps['Step-BendingY-L'+ip].frames:
#                allFrames = odb.steps['Step-BendingY-L'+ip].frames
                C=C+par
#                rfsYB=frame.fieldOutputs['RF'].getSubset(region=regOdbYB).values
#                momentNode=odb.rootAssembly.nodeSets['SET-NODE-MOMENT']
#                y0=momentNode.nodes[0][0].coordinates[1]
#                z0=momentNode.nodes[0][0].coordinates[2]
#            
#                sumMy=0 # to be incrementally summed...
#                for counter, rfYB in enumerate(rfsYB):
#                    rfy=rfYB.data[1]
#                    rfz=rfYB.data[2]
#                    
#                    y=regOdbYB.nodes[0][counter].coordinates[1]
#                    z=regOdbYB.nodes[0][counter].coordinates[2]
#                    
#                    armY=y-y0
#                    armZ=z-z0
#                    
#                    momY1=rfy*armZ
#                    momY2=-rfz*armY
#                    momY=momY1+momY2
#                    sumMy=sumMy+momY
                sumMy=C*E
        res=res+str(C)+'\t'+str(sumMy)+'\n'
        
        f.write(res)
        f.close()
   
def printStuff(modelName):
    odbName = modelName+'.odb'
    odb = session.openOdb(odbName)
    elements = odb.rootAssembly.elements
    
    session.openOdb(name=odbName)
    odbObj = session.odbs[odbName]
    session.pngOptions.setValues(imageSize=SIZE_ON_SCREEN)
    session.viewports['Viewport: 1'].setValues(displayedObject=odbObj)
        
        #Show deformation
    leaf = dgo.Leaf(leafType=DEFAULT_MODEL)
    session.viewports['Viewport: 1'].odbDisplay.displayGroup.replace(leaf=leaf)    
    session.viewports['Viewport: 1'].view.setValues(cameraPosition=(178.813, 0, 
            -0.0708677))
    session.viewports['Viewport: 1'].view.setValues(nearPlane=104.889, 
        farPlane=182.737, width=24.0845, height=8.89318, cameraPosition=(
        178.813, 0.112238, 0.0897802), cameraTarget=(35, 0.112238, 0.0897803))
    session.viewports['Viewport: 1'].view.setValues(cameraPosition=(178.813, 
        0.112238, 0.0897803), cameraUpVector=(0, 0.00163908, 0.999999))
    session.viewports['Viewport: 1'].odbDisplay.display.setValues(plotState=(
        SYMBOLS_ON_DEF, ))
    session.viewports['Viewport: 1'].odbDisplay.setSymbolVariable(
        variableLabel='RF', outputPosition=NODAL, refinement=(COMPONENT, 
        'RF2'), vectorQuantity=VECTOR_COMPONENT, )
    session.printToFile(fileName=modelName+'RF2', format=PNG, 
                        canvasObjects=(session.viewports['Viewport: 1'], ))

# Main program
numSteps = int(sys.argv[-3])    
lineStart = int(sys.argv[-2])
numLines = int(sys.argv[-1])
for i in range(lineStart, lineStart+numLines):
        if i<10:
            ip = str(i)
            fileName = 'usefulFile-pb-YdX-m00'+ip+'.txt'
        elif i<100:
            ip = str(i)
            fileName = 'usefulFile-pb-YdX-m0'+ip+'.txt'
        else: 
            ip = str(i)
            fileName = 'usefulFile-pb-YdX-m'+ip+'.txt'
        
        modelName, dX, dY, th, ky = getUsefulPar(fileName)
        results(modelName,dX,dY,th,ky)
        printStuff(modelName)
