# -*- coding: utf-8 -*-
"""
Created on Mon Feb 26 11:26:58 2018

@author: eivin
"""

from abaqus import *
from abaqusConstants import *
import __main__

import datetime
import section
import regionToolset
import displayGroupMdbToolset as dgm
import part
import material
import assembly
import step
import interaction
import load
import mesh
import optimization
import job
import sketch
import visualization
import xyPlot
import displayGroupOdbToolset as dgo
import connectorBehavior
import sys


def getUsefulPar(fileName):
    file = open(fileName,'r')
    for line in file:
        par = line.split('\t')
    modelName = par[0]
    dX = float(par[1])
    dY = float(par[2])
    th = float(par[3])
    file.close()
    return(modelName,dX,dY,th)
    
def results(modelName,dX,dY,th):  
    # Non-linear
    odbName = modelName+'.odb'
    odb = session.openOdb(odbName)
    
    # The sets of nodes found in the result file:
    regOdbYB=odb.rootAssembly.nodeSets['SET-NODES-YB']
    dispNode=odb.rootAssembly.nodeSets['SET-NODES-YB'].nodes[0][0]
    
    # Number of steps in stepNum
    stepNum = numSteps
    outFileName=odbName.split('.')[0]+'.txt'
#    f=open(outFileName,'a')
#    f.close()
    
    for i in range(stepNum):
        ip = str(i+1)
        res=''
        if i == 0:
            f=open(outFileName,'w')
        else:
            f=open(outFileName,'a')
        for frame in odb.steps['Step-InPlaneY-NL'+ip].frames:
            rfsYB=frame.fieldOutputs['RF'].getSubset(region=regOdbYB).values
            
            sumNy=0 # to be incrementally summed...
            for rfYB in rfsYB:   
                rfy=rfYB.data[1]
                sumNy=sumNy+rfy
            Ny=sumNy/(dX*th*2)
            uy=frame.fieldOutputs['U'].getSubset(region=dispNode).values[-1].data[1]
            epsY=uy/dY
            res=res+ str(epsY)+'\t'+str(Ny)+'\n'
        
        f.write(res)
        f.close()
    
    # Linear
    modelNameL = modelName + '-L'
    odbName = modelNameL+'.odb'
    odb = session.openOdb(odbName)
    
    # The sets of nodes found in the result file:
    regOdbYB=odb.rootAssembly.nodeSets['SET-NODES-YB']
    dispNode=odb.rootAssembly.nodeSets['SET-NODES-YB'].nodes[0][0]
    
    outFileName=odbName.split('.')[0]+'.txt' 
    E=0
    
    for i in range(stepNum):
        ip = str(i+1)
        res=''
        if i == 0:
            f=open(outFileName,'w')
        else:
            f=open(outFileName,'a')
            
        if i == 0:
            for frame in odb.steps['Step-InPlaneY-L'+ip].frames:
                rfsYB=frame.fieldOutputs['RF'].getSubset(region=regOdbYB).values
                
                sumNy=0 # to be incrementally summed...
                for rfYB in rfsYB:   
                    rfy=rfYB.data[1]
                    sumNy=sumNy+rfy
                Ny=sumNy/(dX*th*2) # stress, but calling it load
                uy=frame.fieldOutputs['U'].getSubset(region=dispNode).values[-1].data[1]
                epsY=uy/dY
                res=res+ str(epsY)+'\t'+str(Ny)+'\n'
            E = Ny/epsY
            
        else:
            for frame in odb.steps['Step-InPlaneY-L'+ip].frames:
                rfsYB=frame.fieldOutputs['RF'].getSubset(region=regOdbYB).values
                
#                sumNy=0 # to be incrementally summed...
#                for rfYB in rfsYB:   
#                    rfy=rfYB.data[1]
#                    sumNy=sumNy+rfy
#                Ny=sumNy/(dX*th*2) # stress, but calling it load
                uy=frame.fieldOutputs['U'].getSubset(region=dispNode).values[-1].data[1]
                epsY=uy/dY
                Ny = epsY*E
                res=res+ str(epsY)+'\t'+str(Ny)+'\n'
        
        f.write(res)
        f.close()
   
#def printStuff(modelName):
#    odbName = modelName+'.odb'
#    session.openOdb(name=odbName)
#    odbObj = session.odbs[odbName]
#    
#    session.psOptions.setValues(paperSize=A4, logo=OFF, date=OFF)
#    session.viewports['Viewport: 1'].setValues(displayedObject=odbObj)
#    session.viewports['Viewport: 1'].view.setValues(session.views['Iso'])
#    session.viewports['Viewport: 1'].view.fitView()
##    session.viewports['Viewport: 1'].odbDisplay.display.setValues(plotState=(
##            CONTOURS_ON_DEF, ))
#    session.viewports['Viewport: 1'].odbDisplay.display.setValues(plotState=(
#            UNDEFORMED, ))
#    session.printToFile(fileName=fileName, format=PNG, 
#                        canvasObjects=(session.viewports['Viewport: 1'], ))
#    session.odbs[odbName].close()

# Main program
numSteps = int(sys.argv[-3])      
lineStart = int(sys.argv[-2])
numLines = int(sys.argv[-1])
for i in range(lineStart, lineStart+numLines):
        if i<10:
            ip = str(i)
            fileName = 'usefulFile-pt-m00'+ip+'.txt'
        elif i<100:
            ip = str(i)
            fileName = 'usefulFile-pt-m0'+ip+'.txt'
        else: 
            ip = str(i)
            fileName = 'usefulFile-pt-m'+ip+'.txt'
        
        modelName, dX, dY, th = getUsefulPar(fileName)
#        modelName = 'pt-'+modelName
        results(modelName,dX,dY,th)
#        printStuff(modelName)
