# -*- coding: utf-8 -*-
"""
Created on Mon Feb 26 11:27:10 2018

@author: eivin

"""
import sys
import numpy as np
import os, errno
#import os
import time
import subprocess as sp
import matplotlib.pyplot as plt

def getDataFiles():
    dataFile=open(dataFileName)    
    modelsData=[]
    for line in dataFile:
        dataList=[]
        data=line.split()
        for d in data:
            dataList.append(d.strip(' \t\n\r'))
        modelsData.append(dataList)         
    dataFile.close()
    
    if len(modelsData) < numLines:
        print('Too many jobs requested!\n')
        sys.exit(0)
    elif (lineStart-1) < 0:
        print('Invalid start number!\n')
        sys.exit(0)
    elif (len(modelsData)-(lineStart-1)) < numLines:
        print('Not enough datalines left to give', numLines,'results\n')   
        sys.exit(0)
    else:
        print('Number of lines accepted!\n')
    return(modelsData) 
    
def makeTheDir(lineStart, numLines):
    start = str(lineStart)
    end = str(lineStart+numLines-1)
    dirName = 'pt_'+start+'_to_'+end+'_unconstrained'
    try:
        os.makedirs(dirName)
    except OSError as e:
        if e.errno != errno.EEXIST:
            raise
    return(dirName)
    
def makeModelBatches(lineStart, numLines):
    start = str(lineStart)
    num = str(numLines)
    
    batch = open('batch.bat','w')
    lines =  ['abaqus cae noGUI=',mainDir,'\\',caseU,'_abaqus.py -- ', start+' ', num+' ', dataFileName+' ',str(numSteps)]
    batch.writelines(lines)
    batch.close()

def runModelBatch():        
    sp.call('batch.bat')

def makeJobBatch():

    for i in range(lineStart, lineStart+numLines):
        if i < 10:
            jobName = case+'-m00'+str(i)
            jobNameL = case+'-m00'+str(i)+'-L'
        elif i < 100:
            jobName = case+'-m0'+str(i)
            jobNameL = case+'-m0'+str(i)+'-L'
        else:
            jobName = case+'-m'+str(i)
            jobName = case+'-m'+str(i)+'-L'
        jobs = open('jobSubmit'+str(i)+'.bat','w')
        jobs.write('')
        jobs.close()
        jobs = open('jobSubmit'+str(i)+'.bat','a')
        jobs.write('(\n')        
        lines = ['abaqus job=', jobName, ' ', 'input=', jobName, ' ask_delete=OFF','\n']
        linesL = ['abaqus job=', jobNameL, ' ', 'input=', jobNameL, ' ask_delete=OFF', '\n']
        jobs.writelines(lines)
        jobs.writelines(linesL)
        jobs.write(')')    
        jobs.close()
    
def submitJobs():
    for i in range(lineStart, lineStart+numLines):
        print('Running Jobs...\n')
        sp.call('jobSubmit'+str(i)+'.bat')
        checker(2)
        checker(3)
    
def checker(var):
    if var == 1:
        check = 0
        while check == 0:    
            for fname in os.listdir(jobDir):
                if fname.endswith('.inp'):
                    check = 1
                    print('The models are done!\n')
                    break
            else:
                time.sleep(0.1)
                
    elif var == 2:
        check = 0
        while check == 0:    
            for fname in os.listdir(jobDir): # '.' - means current directory
                if fname.endswith('.lck'):
                    check = 1
                    break
            else:
                time.sleep(1)
                
    elif var == 3:
        check = 0
        while check == 0:    
            for fname in os.listdir(jobDir): 
                if fname.endswith('.lck'):
                    time.sleep(1)
                    break
            else:
                check = 1
                print('The simulations are done!\n')
      
def getResults():
    s = str(lineStart)
    n = str(numLines)
    command ='abaqus cae noGUI=',mainDir,'\\',caseU,'_results.py -- {0} {1} {2}'.format(numSteps,s,n)
    
    results = open('results.bat','w')
    results.writelines(command)
    results.close()
    sp.call('results.bat')
    
def plotResults(r,mDat):
   
    x = []
    y = []
    xL = []
    yL = []
    docName = 'values'+str(lineStart)+'-'+str(lineStop)+'.txt'
    values = open(docName, 'w')                                  
    line = ['Name','\t', 'Strain','\t', 'Load', '\n']
    values.writelines(line)
    values.close()
    values = open(docName, 'a')
    for i in range(lineStart,lineStop+1):
        nl ='Non-linear'
        l = 'Linear'
         # Non-linear
        plt.figure()
        if i<10:
            ip = str(i)
            x, y = np.loadtxt(case+'-m00'+ip+'.txt', delimiter='\t', unpack=True)
            plt.plot(x,y,label=nl,ls='--',c='b')
        elif i<100:
            ip = str(i)
            x, y = np.loadtxt(case+'-m0'+ip+'.txt', delimiter='\t', unpack=True)
            plt.plot(x,y,label=nl,ls='--',c='b')
        else: 
            ip = str(i)
            x, y = np.loadtxt(case+'t-m'+ip+'.txt', delimiter='\t', unpack=True)
            plt.plot(x,y,label=nl,ls='--',c='b')
            
         # Linear        
        if i<10:            
            xL, yL = np.loadtxt(case+'-m00'+ip+'-L.txt', delimiter='\t', unpack=True)
            plt.plot(xL,yL,label=l,c='tab:orange')
        elif i<100:
            ip = str(i)
            xL, yL = np.loadtxt(case+'-m0'+ip+'-L.txt', delimiter='\t', unpack=True)
            plt.plot(xL,yL,label=l,c='tab:orange')
        else: 
            ip = str(i)
            xL, yL = np.loadtxt(case+'-m'+ip+'-L.txt', delimiter='\t', unpack=True)
            plt.plot(xL,yL,label=l,c='tab:orange')
            
        errStrain, errLoad, preValStrain, preValLoad, diffErr, diffPre = errorCrit(x,y,xL,yL)
#        criticalPoint = (diffErr+diffPre)/2
        criticalStrain = (errStrain + preValStrain)/2
#        criticalLoad = (errLoad+preValLoad)/2
#        xErr, yErr = [criticalStrain, criticalStrain], [0, criticalLoad]
#        xErr2, yErr2 = [0, criticalStrain], [criticalLoad, criticalLoad]
        xErr, yErr = [errStrain, errStrain], [0, errLoad]
        xErr2, yErr2 = [preValStrain, preValStrain], [0, preValLoad]
        plt.plot(xErr, yErr, marker =',',c='r',lw=1)
        plt.plot(xErr2, yErr2, marker =',',c='r',lw=1)
#        myText = str(criticalPoint)
#        plt.text(criticalStrain, criticalLoad*0.5, myText)
#        plt.text(0, criticalLoad*1.1, criticalLoad)
#        plt.text(criticalStrain*1.05, 0, criticalStrain)
        if lineStart == 1:
            parameterVar=5
        elif lineStart == 7:
            parameterVar=7
        elif lineStart == 13:
            parameterVar=6
        elif lineStart == 19:
            parameterVar=4
        parameters = modelsData[i-1][parameterVar]
        line = [mDat[i-1][0], '\t', str(parameters), '\t', str(criticalStrain), '\n']
        values.writelines(line)
        plt.legend()
        plt.xlabel('Strain, [mm/mm]')
        plt.ylabel('Load, [N/(mm^2)]')
        plt.title('In-Plane Tension of YdX in Y')
        plt.xlim(0,)
        plt.ylim(0,)
#    figManager = plt.get_current_fig_manager()
#    figManager.window.showMaximized()   
        plt.show()    
#        plt.savefig('C:\\Users\\Eivind\\OneDrive - NTNU\\Master\\Just pictures\\Results from parameter study\\PureTension_YdX\\'+case+'-'+str(i)+'.png')
#        plt.savefig('C:\\Users\\Eivind\\OneDrive - NTNU\\Master\\Just pictures\\Results from parameter study\\PureTension_YdX\\'+case+'-'+str(i)+'.pdf',format='pdf')
    values.close()
    return(docName)
def errorCrit(x,y,xL,yL):
    # This function will find the strain and the load calues at the specific error criteria
    
    # Height
   
    diff=[]
    for i in range(len(x)):
        if i == 0:            
            diff.append(0)
            continue
        else:
#            print(x[i])
#            print(y[i])
#            h = (y[i]-y[i-1])/(x[i]-x[i-1])
            
            h = y[i]
            hL = yL[i]
#            print(h)
#            print(hL)
            diff.append(h/hL)
            print(diff[i])
            
            
        if (1-error) < diff[i] < (1+error):
            mess = 'Inside error criteria!'
#            diff[i] = (h-hL)/(hL)
            print('The difference is: ', diff[i])
            valX = 0
            valY = 0
            prevalX = 0
            prevalY = 0                
            
        else:
            mess = 'Error criteria reached!'
            valX = x[i]
            valY = y[i]
            prevalX = x[i-1]
            prevalY = y[i-1]
            print('The difference is: ', diff[i])
            
            break
        print(mess)
        
    print(mess)
    return(valX,valY,prevalX,prevalY,diff[i],diff[i-1])

def plotLast(file):
    transVal = np.loadtxt(file, delimiter='\t', skiprows=1, usecols=2, unpack=False)
    par = np.loadtxt(file, delimiter='\t', skiprows=1, usecols=1, unpack=True)
    print(transVal)
    print(par)
    label=0
    if lineStart == 1:
        label='b'
    elif lineStart == 7:
        label='d'
    elif lineStart == 13:
        label='c'
    elif lineStart == 19:
        label='a'
    
    plt.figure()
    plt.plot(par,transVal,label='',ls='-',c='r')
    
#    plt.ylim(0.12,0.13)
    plt.xlabel('Parameter variation of '+label+', [mm]')
    plt.ylabel('Non-linear transition, [Strain]')
    plt.title('In-Plane Tension of YdX in Y')
#    plt.legend()
    plt.show()
    plt.savefig('C:\\Users\\Eivind\\OneDrive - NTNU\\Master\\Just pictures\\Results from parameter study\\PureTension_YdX\\'+'variation_of_'+label+'_uc.png')
    plt.savefig('C:\\Users\\Eivind\\OneDrive - NTNU\\Master\\Just pictures\\Results from parameter study\\PureTension_YdX\\'+'variation_of_'+label+'_uc.pdf',format='pdf')    
    
# =============================================================================
# Global parameters
# =============================================================================
error = 0.10
numSteps = 10
case = 'pt-YdX'
caseU = 'pt_YdX'
mainDir = 'C:\\Users\\Eivind\\Documents\\Master\\FinalAnalysis\\Geometric\\PureTension_YdX'
printNumber = 1
# =============================================================================
# Main program
# =============================================================================

#lineStart = int(input('What is the start line in the models data? '))
#numLines = int(input('How many models shall be created an run? '))
lineStart = 19
numLines = 6
lineStop = lineStart + numLines - 1


os.chdir(mainDir)
dirName = makeTheDir(lineStart, numLines)
os.chdir(os.getcwd()+'\\'+dirName)
jobDir = os.getcwd()
dataFileName = mainDir +'\\modelsData_YdX.txt'

modelsData = getDataFiles()

#
#makeModelBatches(lineStart, numLines)
#runModelBatch()
#
#checker(1)
#
#makeJobBatch()
#submitJobs()
#
#getResults()

valDoc = plotResults(numLines, modelsData)
plotLast(valDoc)